"""Code generated by Speakeasy (https://speakeasyapi.dev). DO NOT EDIT."""

from __future__ import annotations
from clerk_dev.types import BaseModel, Nullable
from enum import Enum
from pydantic import model_serializer
from typing import Optional, TypedDict
from typing_extensions import NotRequired


class OrganizationObject(str, Enum):
    ORGANIZATION = "organization"


class OrganizationPublicMetadataTypedDict(TypedDict):
    pass
    

class OrganizationPublicMetadata(BaseModel):
    pass
    

class OrganizationPrivateMetadataTypedDict(TypedDict):
    pass
    

class OrganizationPrivateMetadata(BaseModel):
    pass
    

class OrganizationTypedDict(TypedDict):
    object: OrganizationObject
    id: str
    name: str
    slug: str
    max_allowed_memberships: int
    public_metadata: OrganizationPublicMetadataTypedDict
    private_metadata: OrganizationPrivateMetadataTypedDict
    created_at: int
    r"""Unix timestamp of creation.

    """
    updated_at: int
    r"""Unix timestamp of last update.

    """
    members_count: NotRequired[Nullable[int]]
    admin_delete_enabled: NotRequired[bool]
    created_by: NotRequired[str]
    

class Organization(BaseModel):
    object: OrganizationObject
    id: str
    name: str
    slug: str
    max_allowed_memberships: int
    public_metadata: OrganizationPublicMetadata
    private_metadata: OrganizationPrivateMetadata
    created_at: int
    r"""Unix timestamp of creation.

    """
    updated_at: int
    r"""Unix timestamp of last update.

    """
    members_count: Optional[Nullable[int]] = None
    admin_delete_enabled: Optional[bool] = None
    created_by: Optional[str] = None
    
    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["members_count", "admin_delete_enabled", "created_by"]
        nullable_fields = ["members_count"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)

            if val is not None:
                m[k] = val
            elif not k in optional_fields or (
                    k in optional_fields
                    and k in nullable_fields
                    and (self.__pydantic_fields_set__.intersection({n}) or k in null_default_fields) # pylint: disable=no-member
                ):
                m[k] = val

        return m
        
